package sample.activity;

import sample.component.ExceptionMaker;

import java.util.Map;

import com.poscoict.glueframework.biz.activity.GlueActivity;
import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.context.GlueStaticContext;

public class ExceptionTest extends GlueActivity<GlueContext> {
    // Do not define the Class Member Variable!!
    public String runActivity(GlueContext ctx) {
        System.out.println(String.format("파일명 : %s", Thread.currentThread().getStackTrace()[1].getFileName()));
        System.out.println(String.format("%s.%s(%s)", Thread.currentThread().getStackTrace()[1].getClassName(), Thread.currentThread().getStackTrace()[1].getMethodName(), Thread.currentThread().getStackTrace()[1].getLineNumber()));

        Map<String, String> transitions = this.getTransition();
        System.out.println(transitions);

        ExceptionMaker component = GlueStaticContext.getBeanFactory().getBeanObject("biz-component", ExceptionMaker.class);
        if (ctx.containsKey("case1")) {
            System.out.println("<transition name=failure ... />가 존재하지 않아 Exception 처리하지 않습니다.");
            component.doSomething();
            ctx.put("input", "GlueException");
        } else if (ctx.containsKey("case2")) {
            System.out.println("try~catch 구문으로 Exception처리를 수행하였으므로 <transition name=success ... />로 진행됩니다.");
            try {
                component.doSomething();
            } catch (Throwable t) {
                System.out.println("Exception 처리완료.");
            }
            ctx.put("input", "GlueException");
        } else if (ctx.containsKey("case3")) {
            System.out.println("Exception을 <transition name=failure ... />에서 처리합니다.");
            component.doSomething();
            ctx.put("input", "GlueException");
        }
        return GlueBizControlConstants.SUCCESS;
    }
}